version: 1

containers:
  main:
    image: nextcloud:30.0.5
    mounts:
      data:
        main/data: /var/www/html
    environment:
      MYSQL_DATABASE: nextcloud
      REDIS_HOST: cache.{{ user }}-nextcloud.svc.cluster.local
      MYSQL_HOST: db.{{ user }}-nextcloud.svc.cluster.local
      MYSQL_USER: {{ derive_entropy(identifier="db_username") }}
      MYSQL_PASSWORD: {{ derive_entropy(identifier="db_password") }}
      {% if settings.username != "" %}
      NEXTCLOUD_ADMIN_USER: '{{ settings.username }}'
      {% endif %}
      NEXTCLOUD_ADMIN_PASSWORD: {{ derive_entropy(identifier="password") }}
      NEXTCLOUD_TRUSTED_DOMAINS: '"*"'
      TRUSTED_PROXIES: "10.42.0.0/16"
      OVERWRITEPROTOCOL: "https"
    ingress_port: 80
    fs_group: 33
  cron:
    image: nextcloud:30.0.5
    mounts:
      data:
        main/data: /var/www/html
    environment:
      MYSQL_DATABASE: nextcloud
      REDIS_HOST: cache.{{ user }}-nextcloud.svc.cluster.local
      MYSQL_HOST: db.{{ user }}-nextcloud.svc.cluster.local
      MYSQL_USER: {{ derive_entropy(identifier="db_username") }}
      MYSQL_PASSWORD: {{ derive_entropy(identifier="db_password") }}
    entrypoint: /cron.sh
  db:
    image: mariadb:11.3.2
    command: --transaction-isolation=READ-COMMITTED --binlog-format=ROW --skip-innodb-read-only-compressed
    mounts:
      data:
        db/data: /var/lib/mysql
    environment:
      MARIADB_PASSWORD: {{ derive_entropy(identifier="db_password") }}
      MARIADB_DATABASE: nextcloud
      MARIADB_USER: {{ derive_entropy(identifier="db_username") }}
      MARIADB_ROOT_PASSWORD: {{ derive_entropy(identifier="db_root_password") }}
    user: 1000:1000
    internal_ports:
      3306: 3306
  cache:
    image: redis:7.2.4
    ulimits:
      memlock: -1
    mounts:
      data:
        redis/data: /data
    user: 1000:1000
    internal_ports:
      6379: 6379
  imaginary:
    image: h2non/imaginary:1.2.4
    environment:
       PORT: 9000
    command: ["-enable-url-source"]
    internal_ports:
      9000: 9000

